#include <iostream>
#include <cmath>

double PTAT_grad = 0.021632431074977;
double PTAT_offset = 2112.093261718750;
int gradscale = 24;
int VddScGrad = 15;
int VddScOff = 18;
float Vdd_th1 = 48057;
float Vdd_th2 = 47808;
float PTAT_th1 = 38381;
float PTAT_th2 = 49382;
int epsilon = 100;
int GlobalGain = 8500;
int PCSCALEVAL = pow(10,8);
float PixC_max = 69108656;
float PixC_min = 51325336;


int ThGrad[16][16] = {{8543,16990,7161,6875,6904,2937,14506,11045,12141,10235,14601,12707,8227,14429,9478,15805},{ 8811,15745,7113,14053,14697,14530,15173,11980,10771,9567,14619,17467,7655,13577,10574,15000},{13696,12606,12290,15614,13797,8775,15257,17884,14214,17169,14095,13737,19623,10080,21506,19522},{11390,12266,13154,12969,12546,14023,14774,14869,14488,14494,15298,16025,15179,16174,16013,15269 },{ 9371,18700,8608,10765,9532,6309,17240,14446,16073,11879,16877,16639,10705,16496,13094,16657 },{ 10920,16514,9430,16996,16007,17479,17818,14202,13326,10842,17550,20136,8936,15423,13374,15977 },{ 14846,14446,11819,17419,14703,8757,18503,18807,15596,18855,16293,14965,19957,12790,23263,21577 },{ 12999,12939,13702,15197,13845,14244,16293,17514,15227,16257,16460,16478,17044,18515,17425,16859 },{ 12040,13261,15173,14292,14577,14768,15846,15346,15811,16555,16257,16537,16823,18331,17973,16186 },{ 10538,9865,17300,18414,19194,11956,13773,12838,14464,15072,13636,12755,17765,18051,11831,14268  },{ 8412,12969,10932,10860,11581,17479,13809,18545,20850,11271,12683,14154,15769,17103,16192,19933 },{ 16394,21923,8745,11831,13797,20565,13344,15453,16585,18152,9692,14607,20433,14792,14405,20660 },{ 13017,12242,13410,15084,15257,14923,17038,16079,16049,16794,16293,17598,17812,18485,17765,18801 },{ 12373,9996,16412,19838,19939,11551,13708,11956,14238,15215,13535,12933,16871,18700,12427,14709 },{  8555,12766,10795,11879,11045,17455,15280,18682,21679,12058,14077,13845,16234,16114,16388,21101 },{ 15078,20267,8698,11468,13732,19921,11551,15406,15197,17270,7482,15185,17145,13779,11754,18420}};

int ThOffset[16][16] = 
	{{-51,-121,-52,-51,-43,-33,-98,-73,-85,-69,-92,-72,-47,-87,-57,-93},
	{-49,-108,-52,-95,-98,-90,-99,-77,-59,-49,-87,-98,-35,-76,-57,-84},
	{-78,-80,-74,-103,-83,-48,-87,-111,-84,-103,-75,-75,-120,-53,-128,-109},
	{-75,-78,-81,-80,-78,-83,-84,-84,-84,-82,-84,-85,-83,-85,-83,-77},
	{-59,-124,-54,-59,-47,-38,-102,-78,-92,-69,-94,-79,-50,-89,-64,-92},
	{-54,-108,-55,-100,-99,-94,-101,-79,-62,-48,-90,-101,-34,-76,-59,-81},
	{-82,-84,-71,-105,-83,-45,-93,-111,-84,-104,-77,-75,-117,-57,-128,-112},
	{-80,-79,-81,-83,-79,-81,-86,-88,-82,-84,-85,-83,-85,-88,-83,-80},
	{-76,-80,-83,-79,-81,-81,-85,-81,-84,-85,-82,-83,-82,-85,-84,-77},
	{-61,-47,-97,-111,-107,-58,-63,-63,-63,-69,-65,-56,-89,-93,-43,-65},
	{-40,-76,-47,-59,-51,-92,-67,-95,-121,-40,-59,-63,-70,-88,-82,-95},
	{-92,-124,-34,-65,-80,-119,-61,-81,-72,-89,-30,-64,-92,-72,-47,-106},
	{-75,-75,-77,-80,-81,-80,-85,-82,-82,-83,-80,-84,-83,-84,-81,-79},
	{-62,-46,-93,-114,-107,-55,-61,-58,-60,-68,-62,-55,-85,-93,-43,-63},
	{-37,-74,-45,-61,-48,-90,-69,-94,-122,-40,-60,-60,-68,-84,-82,-95},
	{-89,-120,-35,-64,-80,-118,-57,-81,-71,-88,-26,-68,-87,-74,-46,-108}};


int VddCompGrad[16][16] = 
	{{394,428,750,853,669,543,777,784,606,663,904,589,693,611,938,773},
	{767,745,502,833,654,927,541,463,783,776,741,909,983,684,719,740},
	{633,659,601,839,625,663,590,638,551,565,759,672,638,729,461,642},
	{546,780,884,720,511,912,747,1175,566,892,898,827,726,1195,889,850},
	{394,428,750,853,669,543,777,784,606,663,904,589,693,611,938,773},
	{767,745,502,833,654,927,541,463,783,776,741,909,983,684,719,740},
	{633,659,601,839,625,663,590,638,551,565,759,672,638,729,461,642},
	{546,780,884,720,511,912,747,1175,566,892,898,827,726,1195,889,850},
	{359,427,543,729,625,473,964,721,572,749,654,525,880,1068,512,783},
	{535,405,587,332,618,786,848,914,836,707,449,774,538,743,738,822},
	{919,821,577,535,324,731,1012,571,767,728,877,641,664,731,655,869},
	{843,684,640,399,573,547,815,634,612,923,425,693,1132,432,1007,699},
	{359,427,543,729,625,473,964,721,572,749,654,525,880,1068,512,783},
	{535,405,587,332,618,786,848,914,836,707,449,774,538,743,738,822},
	{919,821,577,535,324,731,1012,571,767,728,877,641,664,731,655,869},
	{843,684,640,399,573,547,815,634,612,923,425,693,1132,432,1007,699}};


int VddCompOff[16][16] =
	{{-627,-846,-1086,-1325,-1029,-823,-1284,-1291,-1097,-999,-1455,-992,-1081,-1106,-1477,-1273},
	{-1141,-1270,-784,-1317,-1117,-1406,-975,-807,-1215,-1222,-1202,-1430,-1442,-1100,-1157,-1131},
	{-973,-1010,-1002,-1367,-1003,-1040,-1014,-1122,-974,-953,-1190,-1083,-1184,-1136,-965,-1127},
	{-881,-1161,-1317,-1148,-864,-1418,-1187,-1737,-934,-1353,-1376,-1294,-1174,-1845,-1452,-1353},
	{-627,-846,-1086,-1325,-1029,-823,-1284,-1291,-1097,-999,-1455,-992,-1081,-1106,-1477,-1273},
	{-1141,-1270,-784,-1317,-1117,-1406,-975,-807,-1215,-1222,-1202,-1430,-1442,-1100,-1157,-1131},
	{-973,-1010,-1002,-1367,-1003,-1040,-1014,-1122,-974,-953,-1190,-1083,-1184,-1136,-965,-1127},
	{-881,-1161,-1317,-1148,-864,-1418,-1187,-1737,-934,-1353,-1376,-1294,-1174,-1845,-1452,-1353},
	{-555,-771,-938,-1152,-1018,-809,-1447,-1175,-943,-1155,-1044,-881,-1319,-1601,-863,-1249},
	{-802,-570,-951,-629,-1004,-1150,-1264,-1341,-1221,-1054,-754,-1123,-916,-1184,-1134,-1223},
	{-1263,-1204,-857,-842,-495,-1168,-1536,-993,-1261,-966,-1275,-955,-975,-1176,-1083,-1316},
	{-1261,-1107,-855,-642,-1018,-974,-1188,-1025,-947,-1447,-634,-1057,-1740,-744,-1509,-1163},
	{-555,-771,-938,-1152,-1018,-809,-1447,-1175,-943,-1155,-1044,-881,-1319,-1601,-863,-1249},
	{-802,-570,-951,-629,-1004,-1150,-1264,-1341,-1221,-1054,-754,-1123,-916,-1184,-1134,-1223},
	{-1263,-1204,-857,-842,-495,-1168,-1536,-993,-1261,-966,-1275,-955,-975,-1176,-1083,-1316},
	{-1261,-1107,-855,-642,-1018,-974,-1188,-1025,-947,-1447,-634,-1057,-1740,-744,-1509,-1163}};
	

int P[16][16] = 
	{{1570,8889,14673,20770,21425,23220,27438,22685,26929,27044,30058,20577,20440,6822,5968,0},
	{7767,23591,21725,27751,29975,31738,36881,32068,36707,39025,33233,33400,31676,21153,18208,10927},
	{17604,21657,34657,33912,36129,42474,40640,43312,47236,39512,38415,34066,31059,26279,26273,13998},
	{20498,29069,35791,41969,43320,46386,49526,52825,55700,50002,49541,42080,45820,37254,35463,20059},
	{23533,30849,37920,45812,46489,48429,53296,48472,53523,52080,56073,45829,44681,29951,29820,19365},
	{22331,39432,38329,46298,48269,50167,55064,50655,56051,57294,51079,51718,48494,37738,33595,25890},
	{30476,35296,48243,47956,50419,56662,56150,58748,62675,54864,53716,48110,44419,39942,38997,25907},
	{30020,38355,45681,51521,53269,56548,60220,63424,65535,61141,60687,51932,55828,47600,44415,28497},
	{29578,39914,43567,46082,56642,54704,49505,58457,64660,61987,53140,55149,46262,43552,38788,28514},
	{24154,31035,42436,42483,50719,46654,54922,52857,56268,53526,52787,46930,44524,41092,33025,25774},
	{23364,26650,34762,43196,46022,49475,51491,51338,48421,46536,43325,45884,44861,35795,33786,24474},
	{23698,30129,28846,39340,42502,40898,45698,47797,46244,45942,47855,40664,44327,35307,31397,20042},
	{20048,28222,32464,36260,45111,42885,47240,46833,51454,48558,41152,43646,36101,33604,28394,21078},
	{11876,17685,28332,29208,35634,32207,39599,36832,40527,38276,36485,33059,31029,28364,21023,15097},
	{6670,10209,17462,25723,26532,30686,32807,33758,30817,28653,25712,28767,27989,20656,19609,11760},
	{1670,6760,6878,14778,17533,16117,19596,22111,21421,20303,21894,16773,20129,13307,9408,1426}};

